#include <iostream.h>
#include <strstream.h>
#include "query.h"

int sscanf(char*, char*, ...);

char SubQuery::buffer[300];

bool StrQuery::getfrombuf(){
  int goodlen, craplen, buflen;
  if (buffer[0]==0) return false;
  craplen = strspn(buffer," \n\t\r");
  goodlen = strcspn(buffer+craplen, " \n\t\r");
  if (goodlen==0) {
    buffer[0]=0;
    return false;
  }
  //  responsestring = new char[goodlen+1]; // if we want to alloc new string
  
  if (goodlen>0){
    strncpy (responsestring,buffer+craplen,
	   (responselength>goodlen) ? goodlen : responselength);
    responsestring[((responselength>goodlen) ? goodlen : responselength)]=0;
  }
  else {
    strncpy (responsestring,buffer+craplen, goodlen);
    responsestring[goodlen]=0;
  }
  if (craplen+goodlen==(buflen=strlen(buffer))){
    buffer[0]=0;
    return true;
  }
  //  char *newbuf = new char[buflen+1-craplen-goodlen];
  strcpy(buffer, buffer+craplen+goodlen);
  return true;
}

char *StrQuery::val(){
  return responsestring;
}


bool DblQuery::getfrombuf(){
  char responsestring[256];
  int goodlen=0, craplen, buflen, extralen;
  if (buffer[0]==0) return false;
  craplen = strcspn(buffer,"-0123456789.");
  if (buffer[craplen]=='-') goodlen=1;
  goodlen += strspn(buffer+craplen+goodlen, "0123456789");
  if (buffer[craplen+goodlen]=='.')
    goodlen+= 1+strspn(buffer+craplen+goodlen+1, "0123456789");
  if (((buffer[craplen+goodlen]=='E') || (buffer[craplen+goodlen]=='e'))
    && ((extralen = strspn(buffer+craplen+goodlen+1,"0123456789"))!=0))
    goodlen+=1+extralen;

  if (goodlen==0) {
    buffer[0]=0;
    return false;
  }
  strncpy (responsestring,buffer+craplen, goodlen);
  responsestring[goodlen]=0;
  istrstream(responsestring) >> response;
  if (craplen+goodlen==(buflen=strlen(buffer))){
    buffer[0]=0;
    return true;
  }
  strcpy(buffer, buffer+craplen+goodlen);
  return true;
}

bool CharQuery::getfrombuf(){
  unsigned int craplen;
  
  craplen = strspn(buffer," \n\t\r");       // skip whitespace
  if (craplen==strlen(buffer)) return false;
  response = buffer[craplen];
  strcpy(buffer, buffer+craplen+1);
  return true;
}

bool IntQuery::getfrombuf(){
  char responsestring[256];
  int goodlen=0, craplen, buflen, extralen;
  if (buffer[0]==0) return false;
  craplen = strcspn(buffer,"-0123456789");
  if (buffer[craplen]=='-') goodlen=1;
  goodlen += strspn(buffer+craplen+goodlen, "0123456789");

  if (goodlen==0) {
    buffer[0]=0;
    return false;
  }
  strncpy (responsestring,buffer+craplen, goodlen);
  responsestring[goodlen]=0;
  istrstream(responsestring) >> response;
  if (craplen+goodlen==(buflen=strlen(buffer))){
    buffer[0]=0;
    return true;
  }
  strcpy(buffer, buffer+craplen+goodlen);
  return true;
}
